#!/bin/usr/perl
# CS 642 University of Wisconsin
#
# WARNING:
# Do not use this encryption functionality, it has security vulnerabilities!
#
# Your job is to find and understand the problems
# 

use strict;

use Digest::SHA qw(hmac_sha256_hex);
use Crypt::CBC;

my $key = "\x97\xed\xae\xdd\xcd\x7b\xc8\x40\x96\x4e\x6c\xe8\x20\x16\x91\x5b"; 

# Grab ciphertext from first argument
my $ciphertext = $ARGV[0];
my $ctxt = pack( "H*", $ciphertext );  

# Initialize CBC cipher
my $cipher = Crypt::CBC->new( 
                -key => $key,
                -cipher => "Crypt::OpenSSL::AES"
            );

my $ptxt = $cipher->decrypt( $ctxt );  # Decrypt ciphertext

my ($version,$pad1,$pad2,$ptxt,$digest) = unpack( "V V V L/A* H64", $ptxt );  # Unpack the resulting CBC plaintext

if( $version != 1 ) {  
    # Check the version number
    printf( "Wrong version!\n" );
    exit;
}

if( $pad1 != 0 or $pad2 != 0  ) {
    # Check the padding
    printf( "Padding error: pad1 = %d, pad2 = %d and ptxtlen = %d ", $pad1, $pad2, length($ptxt)  );
    exit( 1 );
}

if( hmac_sha256_hex( $ptxt, $key ) != $digest ) { 
    # Check the digest
    printf "Error, digest is incorrect!\n";
}
else {
    # Plaintext is correct
    print "Message received!\n";
}

